Subject: bug#30993: OpenSSH sshd killed by Shepherd 0.4.0

From: Leo Famulari <[email-masked]>
Date: Thu, 3 May 2018 12:38:08 -0400

On Thu, May 03, 2018 at 05:16:32PM +0200, Martin Castillo wrote:
> 
> 
> On 01.05.2018 22:43, Ludovic Courtès wrote:
> >> Maybe one could somehow strace herd, or change the make-kill-destructor
> >> to log every time it is being executed?
> > 
> > ‘herd status sshd’ displays the last time sshd was respawned, but the
> > info ‘herd’ receives actually includes the dates of all the respawns,
> > not just the last one.  Is that what you’re asking for?
> > 
> 
> My idea was that maybe make-kill-destructor is being called from
> somewhere else. If this is being
> logged, one could rule that out.
> 
> Another wild idea would be sshd killing itself for some reason. stracing
> sshd would tell us, if that's the case. How would one do that? Does
> shepherd provide some debugging functions?
> 
> Or does linux provide a way to log all sent signals so one could find
> the sending process?

I haven't had time to debug this yet, and Shepherd 0.3 still works.

Since nobody else can reproduce the bug, and since I expect OpenSSH to
be commonly used, I suspect some non-deterministic Guile mis-compilation
or filesystem corruption — the system in question is using ext4.